//+-------------------------------------------------------------------------------------------------+
//|                                                                        GWTriDiffMetatrader4.mq4 |
//|                                                      Copyright  2004, MetaQuotes Software Corp.|
//|                                                                       http://www.metaquotes.net/|
//| The GWTriDiffNT7 . Original Author: Glennw - bigmiketrading.com forum - for ThinkorSwim Platform|
//| http://www.bigmiketrading.com/download/vip_elite_circle/862-download.html?view                  |
//| Then ported by me, jabeztrading for Ninjatrader 7.                                              |
//| http://www.bigmiketrading.com/download/vip_elite_circle/884-download.html?view                  |
//|                                                                                                 |
//| Now ported by me, jabeztrading, for Metatrader 4.   10/24/2012                                  |                                                |
//|+------------------------------------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"

///---- Properties
#property indicator_separate_window
#property indicator_buffers    7
#property indicator_color1     LimeGreen 
#property indicator_color2     Red       
#property indicator_color3     DodgerBlue 
#property indicator_color4     DarkSlateGray
#property indicator_color5     Gold
#property indicator_color6     DeepSkyBlue
#property indicator_color7     PaleVioletRed       
#property indicator_width1     3
#property indicator_width2     3
#property indicator_style3     STYLE_DOT
#property indicator_width4     1
#property indicator_width5     1
#property indicator_level1     0
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame         = "Current time frame"; 
extern int    FastTma           = 3;
extern int    SlowMa            = 30;
extern int    SignalPeriod      = 3;
extern int    AppliedPrice      = PRICE_CLOSE;
extern double Multiplier        = 2;

extern bool   ShowArrows        = true;
extern bool   ArrowOnLast       = false;
extern int    arrowSize         = 3;

extern bool   alertsOn          = false;
extern bool   alertsOnCurrent   = true;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = false;
extern bool   alertsNotify      = false;
extern bool   alertsEmail       = false;

//
//
//
//
//

double macdU[];
double macdD[];
double osma[];
double macd[];
double signal[];
double arrowUp[];
double arrowDn[];
double trend1[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8); 
   SetIndexBuffer(0,macdU);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macdD);  SetIndexStyle(1,DRAW_HISTOGRAM); 
   SetIndexBuffer(2,macd);
   SetIndexBuffer(3,signal); 
   SetIndexBuffer(4,osma);
   SetIndexBuffer(5,arrowUp); 
   SetIndexBuffer(6,arrowDn); 
   SetIndexBuffer(7,trend);
   
   if (ShowArrows)
   {
     SetIndexStyle(5,DRAW_ARROW,0,arrowSize); SetIndexArrow(5,159);
     SetIndexStyle(6,DRAW_ARROW,0,arrowSize); SetIndexArrow(6,159);
   }
   else
   {
     SetIndexStyle(5,DRAW_NONE);
     SetIndexStyle(6,DRAW_NONE);
   }
      
         //
         //
         //
         //
         //
         
         FastTma           = MathMax(FastTma,1);
         SlowMa            = MathMax(SlowMa,1);
         SignalPeriod      = MathMax(SignalPeriod,1);          
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
         //
         //
         //
         //
         //
         
   IndicatorShortName(timeFrameToString(timeFrame)+"  GWTriDiff ("+SlowMa+","+SignalPeriod+","+FastTma+")");
return(0);
}

//
//
//
//
//

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                       
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { macdU[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
     if (ArrayRange(trend1,0)!=Bars) ArrayResize(trend1,Bars);
     for (i=limit; i>=0; i--) macd[i]   = iTma(iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i),FastTma,i,0) - iMA(NULL,0,SlowMa,0,MODE_SMA,AppliedPrice,i);   
     for (i=limit; i>=0; i--) signal[i] = iMAOnArray(macd,0,SignalPeriod,0,MODE_SMA,i); 			
     for(i=limit, r=Bars-i-1; i>=0; i--,r++)   
     {    
         if (Multiplier<=0) Multiplier=1;  
         osma[i]   = (macd[i]-signal[i])*Multiplier;
         macdU[i]  = EMPTY_VALUE;
         macdD[i]  = EMPTY_VALUE;
	      trend1[r] = trend1[r-1];
		   if (macd[i] > 0) trend1[r] = 1;
	      if (macd[i] < 0) trend1[r] =-1;
	      if (trend1[r] == 1) macdU[i] = macd[i];
		   if (trend1[r] ==-1) macdD[i] = macd[i];
	      
	      //
	      //
	      //
	      //
	      //
	      
		   arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
         if (macd[i] > signal[i]) trend[i] = 1;
	      if (macd[i] < signal[i]) trend[i] =-1;
		   if (trend[i] != trend[i+1])
		   if (trend[i]==1) 
               arrowUp[i] = macd[i];
         else  arrowDn[i] = macd[i];	
      
     }
     manageAlerts();
   return(0);
   }
		   		
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   int displace = 1; if (ArrowOnLast) displace=-1;    
   if (ArrayRange(trend1,0)!=Bars) ArrayResize(trend1,Bars);  
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   { 
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+displace]); 
         macd[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastTma,SlowMa,SignalPeriod,AppliedPrice,Multiplier,2,y);
         signal[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastTma,SlowMa,SignalPeriod,AppliedPrice,Multiplier,3,y);
         osma[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastTma,SlowMa,SignalPeriod,AppliedPrice,Multiplier,4,y);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastTma,SlowMa,SignalPeriod,AppliedPrice,Multiplier,7,y); 
         macdU[i]   = EMPTY_VALUE;
         macdD[i]   = EMPTY_VALUE;
         
         trend1[r]  = trend1[r-1];
		   if (macd[i] > 0)    trend1[r] = 1;
	      if (macd[i] < 0)    trend1[r] =-1;
	      if (trend1[r] == 1) macdU[i] = macd[i];
		   if (trend1[r] ==-1) macdD[i] = macd[i];
	      
	      //
	      //
	      //
	      //
	      //
	      
		   arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
         if (x!=y)
         {
            int z = iBarShift(NULL,0,iTime(NULL,timeFrame,y+1));
            if (trend[i] != trend[z])
               if (trend[i]==1) 
                     arrowUp[i] = macd[i];
               else  arrowDn[i] = macd[i];
         }
     }
     manageAlerts();
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double workTma[][1];
double iTma(double price, double period, int r, int instanceNo=0)
{
   if (ArraySize(workTma)!= Bars) ArrayResize(workTma,Bars); r=Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workTma[r][instanceNo] = price;

      double half = (period+1.0)/2.0;
      double sum  = price;
      double sumw = 1;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = k+1; if (weight > half) weight = period-k;
                sumw  += weight;
                sum   += weight*workTma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" GWTriDiff trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(Symbol()+" GWTriDiff ",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}     